From 08fde415f139d49071aec7514a6926ab75ba6976 Mon Sep 17 00:00:00 2001
From: Stephen Gallagher <sgallagh@redhat.com>
Date: Tue, 2 Feb 2010 14:12:15 -0500
Subject: [PATCH 2/2] Internationalize the command-line help message

---
 server/monitor/monitor.c            |    6 +++---
 server/providers/data_provider_be.c |    2 +-
 server/providers/krb5/krb5_child.c  |    6 +++---
 server/providers/ldap/ldap_child.c  |    6 +++---
 server/util/util.h                  |   10 +++++-----
 5 files changed, 15 insertions(+), 15 deletions(-)

diff --git a/server/monitor/monitor.c b/server/monitor/monitor.c
index ef8ede0..ddbfb6a 100644
--- a/server/monitor/monitor.c
+++ b/server/monitor/monitor.c
@@ -2537,11 +2537,11 @@ int main(int argc, const char *argv[])
         POPT_AUTOHELP
         SSSD_MAIN_OPTS
         {"daemon", 'D', POPT_ARG_NONE, &opt_daemon, 0, \
-         "Become a daemon (default)", NULL }, \
+         _("Become a daemon (default)"), NULL }, \
         {"interactive", 'i', POPT_ARG_NONE, &opt_interactive, 0, \
-         "Run interactive (not a daemon)", NULL}, \
+         _("Run interactive (not a daemon)"), NULL}, \
         {"config", 'c', POPT_ARG_STRING, &opt_config_file, 0, \
-         "Specify a non-default config file", NULL}, \
+         _("Specify a non-default config file"), NULL}, \
         { NULL }
     };
 
diff --git a/server/providers/data_provider_be.c b/server/providers/data_provider_be.c
index c0e7e4b..135a3ef 100644
--- a/server/providers/data_provider_be.c
+++ b/server/providers/data_provider_be.c
@@ -1158,7 +1158,7 @@ int main(int argc, const char *argv[])
         POPT_AUTOHELP
         SSSD_MAIN_OPTS
         {"domain", 0, POPT_ARG_STRING, &be_domain, 0,
-         "Domain of the information provider (mandatory)", NULL },
+         _("Domain of the information provider (mandatory)"), NULL },
         POPT_TABLEEND
     };
 
diff --git a/server/providers/krb5/krb5_child.c b/server/providers/krb5/krb5_child.c
index a1a32ea..08e16b4 100644
--- a/server/providers/krb5/krb5_child.c
+++ b/server/providers/krb5/krb5_child.c
@@ -924,11 +924,11 @@ int main(int argc, const char *argv[])
     struct poptOption long_options[] = {
         POPT_AUTOHELP
         {"debug-level", 'd', POPT_ARG_INT, &debug_level, 0,
-         "Debug level", NULL},
+         _("Debug level"), NULL},
         {"debug-timestamps", 0, POPT_ARG_INT, &debug_timestamps, 0,
-         "Add debug timestamps", NULL},
+         _("Add debug timestamps"), NULL},
         {"debug-fd", 0, POPT_ARG_INT, &debug_fd, 0,
-         "Add debug timestamps", NULL},
+         _("An open file descriptor for the debug logs"), NULL},
         POPT_TABLEEND
     };
 
diff --git a/server/providers/ldap/ldap_child.c b/server/providers/ldap/ldap_child.c
index fad075e..a17bcad 100644
--- a/server/providers/ldap/ldap_child.c
+++ b/server/providers/ldap/ldap_child.c
@@ -324,11 +324,11 @@ int main(int argc, const char *argv[])
     struct poptOption long_options[] = {
         POPT_AUTOHELP
         {"debug-level", 'd', POPT_ARG_INT, &debug_level, 0,
-         "Debug level", NULL},
+         _("Debug level"), NULL},
         {"debug-timestamps", 0, POPT_ARG_INT, &debug_timestamps, 0,
-         "Add debug timestamps", NULL},
+         _("Add debug timestamps"), NULL},
         {"debug-fd", 0, POPT_ARG_INT, &debug_fd, 0,
-         "Add debug timestamps", NULL},
+         _("An open file descriptor for the debug logs"), NULL},
         POPT_TABLEEND
     };
 
diff --git a/server/util/util.h b/server/util/util.h
index 2ea6246..9c8679e 100644
--- a/server/util/util.h
+++ b/server/util/util.h
@@ -56,12 +56,12 @@ void debug_fn(const char *format, ...);
 errno_t set_debug_file_from_fd(const int fd);
 
 #define SSSD_DEBUG_OPTS \
-		{"debug-level",	'd', POPT_ARG_INT, &debug_level, 0, \
-		 "Debug level", NULL}, \
-                {"debug-to-files", 'f', POPT_ARG_NONE, &debug_to_file, 0, \
-                 "Send the debug output to files instead of stderr", NULL }, \
+        {"debug-level", 'd', POPT_ARG_INT, &debug_level, 0, \
+         _("Debug level"), NULL}, \
+        {"debug-to-files", 'f', POPT_ARG_NONE, &debug_to_file, 0, \
+         _("Send the debug output to files instead of stderr"), NULL }, \
         {"debug-timestamps", 0, POPT_ARG_INT, &debug_timestamps, 0, \
-         "Add debug timestamps", NULL},
+         _("Add debug timestamps"), NULL},
 
 /** \def DEBUG(level, body)
     \brief macro to generate debug messages
-- 
1.6.6